
      IMPLICIT NONE

C---- Express Stuff
      INTEGER nddata(4), procnum, nproc
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC
      INTEGER NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC
      INTEGER procdim(1),proccoord(1)
      COMMON /PROCGRID/ procnum, nproc, procdim, proccoord

      INTEGER  Maxiter, MAXINT
      INTEGER  Nmax, Nrow_max, Ncol_max
      INTEGER  Qmax, Bufmax, intsize
      INTEGER  row, col, val

      PARAMETER ( Maxiter = 10000000 )
      PARAMETER ( MAXINT = 2147483647 )
      PARAMETER ( Nmax = 1024 )
      PARAMETER ( Nrow_max = 512 )
      PARAMETER ( Ncol_max = 64 )
      PARAMETER ( Qmax = 10*(Nrow_max+Ncol_max) )
      PARAMETER ( Bufmax = Nrow_max )
      PARAMETER ( row = 0 )
      PARAMETER ( col = 1 )
      PARAMETER ( val = 2 )
      PARAMETER ( intsize = 4 )


C ----  Parallel stuff
	INTEGER  globside,globisiz,globjsiz,globsites
	INTEGER  lpnum, rpnum
        INTEGER  ADD_OP
	INTEGER  COMB, EDGE, RANTYPE, ANDTYPE, SIZETYPE

	PARAMETER ( ADD_OP  = 0  )
	PARAMETER ( COMB    = 10 )
	PARAMETER ( EDGE    = 20 )
        PARAMETER ( RANTYPE = 30 )
        PARAMETER ( ANDTYPE = 40 )
        PARAMETER ( SIZETYPE = 50 )

C     ***********************************************************
C               Definition of Global variables
C     ************************************************************

      INTEGER  N, ori_nproc, Nrow, Ncol, 
     *         width, twidth, ntile, tnum, cord, proc_order(32)
      INTEGER  source_pnum, source_tnum  
      INTEGER  therm_sweeps, sweeps, measurements, size
      REAL    beta, p, vol
      
      REAL*8   sum_energy, sum_enersq, sum_spins, sum_spinsq
      REAL*8   sum_nits,   sum_nitsq,  sum_size,  sum_sizesq

      INTEGER  spin(0:Nrow_max-1,0:Ncol_max-1)
      INTEGER  oldspin(0:Nrow_max-1,0:Ncol_max-1)

      INTEGER  source(row:col), source_local(row:col)
      INTEGER  cycle
    
      INTEGER  new_counter, old_counter
      LOGICAL*1  all_emptyQ
      LOGICAL*1  cluster(0:Nrow_max-1,0:Ncol_max-1) 

      COMMON  /spins/      spin, oldspin
      COMMON  /clusters/   cluster
      COMMON  /empty_Q/     all_emptyQ
      COMMON  /nbors/      lpnum, rpnum
      COMMON  /counter/    old_counter, new_counter
      COMMON /global_data/ N, ori_nproc, Nrow, Ncol, proc_order,
     *                     width, twidth, ntile, tnum, cord, vol
      COMMON /source_data/ source,  source_local,
     *                     source_tnum, source_pnum 
      COMMON /iterations/  therm_sweeps, sweeps, measurements, size
      COMMON /temp/        beta, p
      COMMON /data/        sum_energy, sum_enersq, sum_spins, sum_spinsq
      common /data1/       sum_nits,   sum_nitsq,  sum_size,  sum_sizesq
      


C--- Variables for Buffer
      INTEGER  send_Lptr, send_Ldata(row:val,0:Bufmax-1), send_Lsize,
     *         send_Rptr, send_Rdata(row:val,0:Bufmax-1), send_Rsize
      INTEGER  recv_Lptr, recv_Ldata(row:val,0:Bufmax-1), recv_Lsize,
     *         recv_Rptr, recv_Rdata(row:val,0:Bufmax-1), recv_Rsize
      
C--- Variables for Queue
      INTEGER  Qhead, Qtail, Qsize, Qdata(0:Qmax-1,row:col)


      COMMON /queue/   Qhead, Qtail, Qdata, Qsize 
      COMMON /Sbuffer/ send_Lptr, send_Ldata, send_Lsize,
     *                 send_Rptr, send_Rdata, send_Rsize
      COMMON /Rbuffer/ recv_Lptr, recv_Ldata, recv_Lsize,
     *                 recv_Rptr, recv_Rdata, recv_Rsize

C--- Random number generator RANMAR

	INTEGER TWO_TO_15, MASK
        PARAMETER ( TWO_TO_15 = 32768 )
        PARAMETER ( MASK = TWO_TO_15 )

        REAL rand_u(97), rand_c, rand_cd, rand_cm
        INTEGER rand_i97, rand_j97, rand_ivec
        COMMON /raset1/ rand_u, rand_c, rand_cd, rand_cm, rand_i97,
     $                  rand_j97, rand_ivec 


